package com.iamberry.wechat.service.task.dao;

import java.util.List;

import com.iamberry.wechat.core.entity.PaperBean;
import com.iamberry.wechat.core.entity.task.WechatTask;
import com.iamberry.wechat.core.entity.task.WechatTaskLogs;

/**
 * @company	深圳爱贝源科技有限公司
 * @website www.iamberry.com
 * @author 	献
 * @tel		18271840547
 * @date	2016年9月20日
 * @explain	微信任务的Dao接口
 */
public interface WechatTaskDao {
	/**
	 * 获取一页的任务
	 * @param bean
	 * @return
	 */
	public List<WechatTask> getAll(PaperBean bean);
	
	/**
	 * 获取总的任务数量
	 * @return
	 */
	public int getCount();
	
	/**
	 * 插入任务数量
	 * @param task
	 * @return
	 */
	public int insertTask(WechatTask task);
	
	/**
	 * 修改任务信息
	 * @param task
	 * @return
	 */
	public int updateTask(WechatTask task);
	
	/**
	 * 插入完成任务的日志
	 * @param logs
	 * @return
	 */
	public int insertLogs(WechatTaskLogs logs);
	
	/**
	 * 根据id，获取完成任务的数据
	 * @param taskID
	 * @return
	 */
	public List<WechatTaskLogs> getByTaskID(Integer taskID);
	
	/**
	 * 根据任务id，用户openid，获取完成的记录
	 * @param logs
	 * @return
	 */
	public Integer getByTaskIdAndOpenId(WechatTaskLogs logs);

	/**
	 * 获取任务
	 * @param taskID
	 * @return
	 */
	public WechatTask getOne(Integer taskID);

	/**
	 * 获取当前正在进行的任务
	 * @return
	 */
	public List<WechatTask> getRunTask(WechatTask task);
}
